import React, { Component } from "react";
import Router from "next/router";
import Link from "next/link";
import Select from "react-select";
import DetailSanksi from "@/components/Main/DetailSanksi";
import Header from "@/components/Main/Header";
import DetailPT from "@/components/Main/DetailPT";
import PermohonanPT from "@/components/Main/PermohonanPT";
import Riwayat from "@/components/PencabutanSanksi/Riwayat";
import { getOneSanksi } from "@/actions/sanksi";
import { addJawabanCabutSanksi } from "@/actions/cabutSanksi";
import ContentWrapper from "@/components/Layout/ContentWrapper";
import { Row, Col, Card, CardBody, FormGroup, Button, Input, Modal, ModalHeader, ModalBody, ModalFooter } from "reactstrap";
import { getPT } from "@/actions/PT";
import Loader from "@/components/Common/Loader";
import { toast } from "react-toastify";
import { connect } from "react-redux";
import { Formik, Form, Field, ErrorMessage } from "formik";
import * as Yup from "yup";

const checkIfFilesAreTooBig = (files) => {
	let valid = true;
	if (files) {
		files.map((file) => {
			if (file.size > 15 * 1024 * 1024) {
				valid = false;
			}
		});
	}
	return valid;
};

const checkIfFilesAreCorrectType = (files) => {
	let valid = true;
	if (files) {
		files.map((file) => {
			if (!["image/jpeg", "image/png"].includes(file.type)) {
				valid = false;
			}
		});
	}
	return valid;
};
const jawabanCabutSanksiSchema = Yup.object().shape({
	status: Yup.string().required("Harap Diisi"),
	keterangan: Yup.string().max(200).notRequired(),
	dokumen: Yup.array().notRequired().test("filesize", "Maksimal ukuran dokumen 15mb", checkIfFilesAreTooBig),
});

let Dropzone = null;
class DropzoneWrapper extends Component {
	state = {
		isClient: false,
	};
	componentDidMount = () => {
		Dropzone = require("react-dropzone").default;
		this.setState({ isClient: true });
	};
	render() {
		return Dropzone ? <Dropzone {...this.props}>{this.props.children}</Dropzone> : null;
	}
}

const selectInstanceId = 1;

class JawabanPencabutanSanksi extends Component {
	constructor(props) {
		super(props);
		this.state = {
			selectedOption: null,
			files: [],
			keterangan: "",
			sanksi: {},
			pt: null,
			data: {},
		};
	}

	static getInitialProps = async ({ query }) => ({ query });

	componentDidMount = async () => {
		const { query, token } = this.props;
		const sanksi = await getOneSanksi(token, query.id);
		const pt = sanksi.data.laporan.pt;
		this.setState({ sanksi, pt });
	};

	toggleModal = () => {
		this.setState({
			modal: !this.state.modal,
		});
	};

	handleChangeSelect = (selectedOption) => {
		this.setState({ selectedOption });
	};

	onDrop = (files) => {
		this.setState({
			files: files.map((file) =>
				Object.assign(file, {
					preview: URL.createObjectURL(file),
				})
			),
			stat: "Added " + files.length + " file(s)",
		});
	};

	uploadFiles = (e) => {
		e.preventDefault();
		e.stopPropagation();
		this.setState({
			stat: this.state.files.length ? "Dropzone ready to upload " + this.state.files.length + " file(s)" : "No files added.",
		});
	};

	clearFiles = (e) => {
		e.preventDefault();
		e.stopPropagation();
		this.setState({
			stat: this.state.files.length ? this.state.files.length + " file(s) cleared." : "No files to clear.",
		});
		this.setState({
			files: [],
		});
	};

	setKeterangan = (e) => {
		this.setState({ keterangan: e.target.value });
	};

	handleSimpan = async () => {
		const { data } = this.state;
		console.log(data);
		const { token, query } = this.props;
		const formdata = new FormData();
		formdata.append("status", data.status);
		formdata.append("keterangan", data.keterangan);
		this.state.files.forEach((e) => {
			formdata.append("dokumen", e);
		});
		const toastid = toast.loading("Please wait...");
		const added = await addJawabanCabutSanksi(token, query.id, formdata);
		if (!added) {
			toast.update(toastid, { render: "All is not good", type: "error", isLoading: false, autoClose: true, closeButton: true });
		} else {
			toast.update(toastid, { render: "All is good", type: "success", isLoading: false, autoClose: true, closeButton: true });
			Router.push({
				pathname: "/app/pencabutan-sanksi",
			});
		}
	};

	render() {
		const { files, selectedOption, sanksi, pt } = this.state;

		const thumbs = files.map((file, index) => (
			<div md={3} key={index}>
				{/* <img className="img-fluid mb-2" src={file.preview} alt="Item" /> */}
				<span className="text-center">{file.name}</span>
			</div>
		));

		return (
			<ContentWrapper unwrap>
				{/* <Header /> */}
				<div className="p-3">
					<div className="content-heading">
						<div>Jawaban Permohonan Pencabutan Sanksi</div>
						<div className="ml-auto">
							<Link href="/app/pencabutan-sanksi">
								<button className="btn btn-sm btn-secondary text-sm">&lt; kembali</button>
							</Link>
						</div>
					</div>
					<Row>
						{sanksi.data ? (
							<Col xl="9">
								<Card className="card-default">
									<CardBody>
										<Row>
											<Col lg={12}>
												<DetailSanksi data={sanksi.data} />
												<PermohonanPT data={sanksi.data.pengajuan.cabut_sanksi} />
												<p className="lead bb">Jawaban</p>
												<Formik
													initialValues={{
														status: "",
														keterangan: "",
														dokumen: [],
													}}
													validationSchema={jawabanCabutSanksiSchema}
													onSubmit={async (data) => {
														this.setState({ data });
														if (sanksi.data.jawaban?.cabut_sanksi) this.toggleModal();
														else await this.handleSimpan();
													}}
												>
													{() => (
														<Form className="form-horizontal">
															<FormGroup>
																<label className="row-form-label">Status:</label>
																<div className="row-md-10">
																	<Field name="status">
																		{({ field, form }) => (
																			<Select
																				instanceId={selectInstanceId + 1}
																				value={this.state.selectedOption}
																				onChange={(e) => {
																					this.handleChangeSelect(e);
																					form.setFieldValue(field.name, e.value);
																				}}
																				options={[
																					{ value: "Diterima", label: "Diterima", className: "State-ACT" },
																					{ value: "Rekomendasi Perbaikan", label: "Rekomendasi Perbaikan", className: "State-ACT" },
																				]}
																			/>
																		)}
																	</Field>
																	<ErrorMessage name="status" component="div" className="form-text text-danger" />
																	{/* <span className="form-text">Pilih Jenis Pelanggaran</span> */}
																</div>
															</FormGroup>
															{selectedOption && selectedOption.value === "Rekomendasi Perbaikan" ? (
																<FormGroup>
																	<label className="row-form-label">Keterangan:</label>
																	<div className="row-md-10">
																		<Field name="keterangan">{({ field }) => <Input type="textarea" {...field} />}</Field>
																		<ErrorMessage name="keterangan" component="div" className="form-text text-danger" />
																		{/* <span className="form-text">Deskripsi pelaporan minimum karakter 50 maksimum 200 karakter</span> */}
																	</div>
																</FormGroup>
															) : (
																""
															)}
															<FormGroup>
																<label className="row-form-label">Upload Dokumen:</label>
																<div className="row-md-10">
																	<Field name="dokumen">
																		{({ field, form }) => (
																			<DropzoneWrapper
																				className=""
																				onDrop={(e) => {
																					this.onDrop(e);
																					form.setFieldValue(field.name, e);
																				}}
																			>
																				{({ getRootProps, getInputProps, isDragActive }) => {
																					return (
																						<div {...getRootProps()} className={"dropzone card p-3 " + (isDragActive ? "dropzone-drag-active" : "")}>
																							<input {...getInputProps()} />
																							<div className="dropzone-previews flex">
																								{this.state.files.length > 0 ? <Row>{thumbs}</Row> : <div className="text-center dz-default dz-message">Klik untuk upload dokumen</div>}
																							</div>
																							<div className="d-flex align-items-center">
																								<small className="ml-auto">
																									<button
																										type="button"
																										className="btn btn-link"
																										onClick={(e) => {
																											this.clearFiles(e);
																											form.setFieldValue(field.name, []);
																										}}
																									>
																										Reset dokumen
																									</button>
																								</small>
																							</div>
																						</div>
																					);
																				}}
																			</DropzoneWrapper>
																		)}
																	</Field>
																	<ErrorMessage name="dokumen" component="div" className="form-text text-danger" />
																	<p className="mrgn-top-5">
																		Ukuran setiap dokumen maksimal 15mb
																	</p>
																</div>
															</FormGroup>
															<FormGroup>
																<div className="row-xl-10">
																	<Button color="primary" type="submit">
																		Simpan
																	</Button>
																</div>
															</FormGroup>
														</Form>
													)}
												</Formik>
											</Col>
										</Row>
									</CardBody>
								</Card>
							</Col>
						) : (
							<Loader />
						)}
						<Col xl="3">{pt ? <DetailPT data={pt} /> : <Loader />}</Col>
					</Row>
					{sanksi.data && (
						<Row>
							<Col>
								<Riwayat data={sanksi.data.jawaban?.cabut_sanksi} />
							</Col>
						</Row>
					)}
				</div>
				<Modal isOpen={this.state.modal} toggle={this.toggleModal}>
					<ModalBody>Apakah anda yakin ingin mengubah jawaban sebelumnya?</ModalBody>
					<ModalFooter>
						<Button color="primary" onClick={this.handleSimpan}>
							Ya
						</Button>{" "}
						<Button color="secondary" onClick={this.toggleModal}>
							Tidak
						</Button>
					</ModalFooter>
				</Modal>
			</ContentWrapper>
		);
	}
}

const mapStateToProps = (state) => ({ user: state.user, token: state.token });
export default connect(mapStateToProps)(JawabanPencabutanSanksi);
